#!/bin/sh
#$1 install or unistall 
SERVICENAME="ZXPS7Config"

install_files()
{
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/pdftozxp7pdf              /usr/lib/cups/filter/
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/rastertozxp7              /usr/lib/cups/filter/
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/ZXPS7Config               /etc/init.d/ZXPS7Config
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/zxp7usb                   /usr/lib/cups/backend/
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/*.rules                   /lib/udev/rules.d/
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/zxp7pnp                   /lib/udev/
    cp -vf /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/ZebraZXPS7Printer.ppd /usr/share/cups/model/ZebraZXPS7Printer.ppd
    chmod 755 /usr/lib/cups/filter/rastertozxp7
    chmod 755 /usr/lib/cups/filter/pdftozxp7pdf
    chmod 755 /usr/lib/cups/backend/zxp7usb
    tar -xzvf  /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/jre1.8.0_111.tar.gz -C /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/   

    mkdir -p  /var/log/ZXPS7Log/
    chmod 777 /var/log/ZXPS7Log/
    mkdir -p /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/config
    chmod 777 /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/config

    if [ -f /usr/lib/libtinyxml.so.2.6.2 ]
    then
        echo "libtinyxml Library File Exists"
    else
        cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/libtinyxml.so.2.6.2 /usr/lib
        echo "libtinyxml Library File Copied"
    fi

    if [ -f /usr/lib/libzmjxml.so ]
    then
        echo "libzmjxml Library File Exists"
    else
        cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/libzmjxml.so /usr/lib
        echo "libzmjxml Library File Copied"
    fi

       

   cp -f /etc/profile $DSTDIR/profile
   echo "xhost +" >> /etc/profile
   . /etc/profile

   echo 'Installation Completed for' $flag
   if [ $flag = "RHEL" ] 
   then
    cp /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/zxps3printerproperties.console /etc/security/console.apps/ZXP7PrinterProperties
    cp /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/zxps3printerproperties.pam /etc/pam.d/zxps7PrinterProperties
    ln -fs /usr/bin/consolehelper /usr/bin/zxps3printerproperties
   else
    echo 'ToDo'
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/com.ubuntu.pkexec.zebra.policy /usr/share/polkit-1/actions/
    chmod -v 644 /usr/share/polkit-1/actions/com.ubuntu.pkexec.zebra.policy 
    cp -v /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/zebra-pkexec /usr/bin/zebra-pkexec
   fi
   #mkdir -p /var/log/cups/ZXPS3Log
   #chmod 777 /var/log/cups/ZXPS3Log
   #chown root:adm /var/log/cups/ZXPS3Log 
   updateUdev
   /etc/init.d/cups restart
   udevadm control --reload-rules
   service cups restart
   return
}

installservice()
{
uninstallservice
echo "--- Installation ---"
update-rc.d "$SERVICENAME" defaults
service "$SERVICENAME" start
}

uninstallservice()
{
echo "--- UnInstallation ---"
service "$SERVICENAME" stop
update-rc.d -f "$SERVICENAME" remove
}
updateUdev()
{
CPY=false
if [ -f /usr/lib/libudev.so.1 ]
then 
   echo "libudev.so.1 is present"
   CPY=true
else
   echo "libudev.so.1 is not present"
   #CPY=false
fi

if [ -f /lib/x86_64-linux-gnu/libudev.so.1 ]
then
   echo "libudev.so.1 is present"
    CPY=true
else
   echo "libudev.so.1 is not present"
    #CPY=false
fi

if [ -f /lib/i386-linux-gnu/libudev.so.1 ]
then
   echo "libudev.so.1 is present"
    CPY=true
else
   echo "libudev.so.1 is not present"
    #CPY=false
fi

MACH=$(uname -m)
if [ $MACH = "i686" ]; then
 echo "32 Bit System"
 ARCH="32Bit"
else
 echo "64 Bit System"
  ARCH="64Bit"
fi

if [ $CPY = false ]
then
    if [ $ARCH = "64Bit" ];then
        cp /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/libudev_64bit.so.1 /usr/lib/libudev.so.1
        echo "64Bit Copy"
    else
        cp /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/libudev_32bit.so.1 /usr/lib/libudev.so.1
        echo "32Bit Copy"
    fi
fi
 

}

disable_enforce()
{
    #echo "###Modified By Zebra Printers###" > /etc/selinux/config
    echo "SELINUX=disabled" > /etc/selinux/config
    echo  "SELINUXTYPE=targeted" >> /etc/selinux/config
    echo   "SETLOCALDEFS=0" >> /etc/selinux/config
    setenforce 0
    echo 0 > /selinux/enforce
  return;
}

uninstall_files()
{
   echo 'Deleting Printers'
   /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/ZXP7RemovePrinter
   echo 'Deleting Printers Successful'
   /etc/init.d/cups restart
   uninstallservice
   rm -rf /etc/init.d/ZXPS7Config
   cp -vf /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/profile /etc/profile
   rm -f /usr/share/applications/Zebra_ZXP7_Series_Printer_Driver-program.desktop
   rm -f /usr/share/applications/Zebra_ZXP7_Series_Printer_Driver-uninstall.desktop
   rm -f /usr/share/applications/Zebra_ZXP7_Series_Card_Printer_Driver-program.desktop
   rm -f /usr/share/applications/Zebra_ZXP7_Series_Card_Printer_Driver-uninstall.desktop
   rm -vf /usr/lib/cups/filter/pdftozxp7pdf
   rm -vf /usr/lib/cups/filter/rastertozxp7
   rm -vf /usr/lib/cups/backend/zxp7usb
   rm -vrf /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver/jar
   rm -vrf /opt/apps/com.zebra.zxp7driver/files/ZebraZXP7Driver
   rm -rv /usr/share/cups/model/ZebraZXPS7*.ppd
   rm -vrf  /usr/share/polkit-1/actions/com.ubuntu.pkexec.zebra.policy
  #rm  -vrf /usr/bin/zebra-pkexec
   mv -vf /etc/cups/cupsd.default.zxp7 /etc/cups/cupsd.conf
   rm -v /usr/share/applications/zebrazxp7.desktop 
   rm -v /usr/share/applications/zebrazxp7uninstall.desktop
   rm -rf /etc/udev/rules.d/10-ZebraZXPS7.rules
   rm -rf /lib/udev/rules.d/10-ZebraZXPS7.rules
   rm -rf /lib/udev/zxp7pnp
   remove_ppd_files
   udevadm control --reload-rules
  /etc/init.d/cups restart
   echo 'Uninstallation Completed'
 
 return

}




remove_ppd_files()
{
	rm -rf /usr/share/cups/model/ZebraZXPS7Printer.ppd
}

###
# Main body of script starts here
###


isMac=$(uname)

 if [ $isMac = "Darwin" ]
  then
   echo "This is MacBook"
   install_uninstall_mac_files
   exit
 fi

 if [ -f /etc/redhat-release ]
  then 
   echo "Redhat or Fedora Version"
   IsRedHat="yes"
  else
   echo "Ubuntu System"
   IsRedHat="no"
  fi
 
#Find Linux Version / Flavour

 if [ $IsRedHat = "yes" ]
  then
   echo "RHEL or Fedora System"

   disable_enforce
   version=$(cat /etc/redhat-release | sed -e 's/[^0-9]//g;s/^$/-1/')
   #RHEL Version 6.1, 6.2, 6.3, 6.4, 6.5, 6.6
   if [ $version == 61 -o $version == 62 -o $version == 63 -o $version == 64 -o $version == 65 -o $version == 66 ]
    then
     flag="RHEL" 
    else
     flag="Fedora"
   fi        
 else
   echo "This is Ubuntu System"
   flag="Ubuntu"
 fi

 if [ $1 = "install" ]
  then
   echo "installing files"
   install_files
   ###installservice
 else
   echo "Uninstalling files"
   uninstall_files
 fi
